package
{
	import de.derhess.video.vimeo.*;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	
	
	public class VimeoInterface extends Sprite
	{
		public var vimeo_player:VimeoPlayer;
		public var durationView:TextField;
		public var currentTimeView:TextField;
		public var play_btn:PlayBTN;
		public var pause_btn:PauseBTN;
		public var seek_btn:SeekBTN;
		public var color_btn:ColorBTN;
		public var newVideo_btn:NewVideoBTN;
		public var size_btn:SizeBTN;
		public var sound_btn:MuteSoundBTN;
		public var unload_btn:UnloadBTN;
		public var quit_btn:QuitBTN;
		
		
		private var counterPlayList:int = 0;
		private var playlist:Array = new Array(4558118, 5989754, 4980912, 3792953);
		
		public function VimeoInterface()
		{
			init();
		}
		
		// This function creates the ugly GUI Interface
		private function init():void
		{
			
			// This is important for the use of the VimeoWrapper Class
			var exampleVideoClipID:int = 3369107;
			var player_width:int = 400;
			var player_height:int = 300;
			
			vimeo_player = new VimeoPlayer(exampleVideoClipID, player_width, player_height);
			vimeo_player.x = vimeo_player.y = 0;
			vimeo_player.addEventListener(VimeoEvent.PLAYER_LOADED, handlePlayerLoaded);	
			vimeo_player.addEventListener(VimeoEvent.DURATION, handleDuration);
			vimeo_player.addEventListener(VimeoEvent.STATUS, handleVimeoStatus);
			addChild(vimeo_player);
			
			///////////
			// Build ugly gui interfaces
			durationView = new TextField();
			durationView.x = 0;
			durationView.y = 300;
			durationView.width = 100;
			addChild(durationView);
			
			currentTimeView = new TextField();
			currentTimeView.x = 110;
			currentTimeView.y = 300;
			currentTimeView.width = 150;
			addChild(currentTimeView);

			play_btn = new PlayBTN();
			play_btn.x = 10;
			play_btn.y = 320
			addChild(play_btn);
			play_btn.addEventListener(MouseEvent.MOUSE_DOWN, handlePlay);
			
			pause_btn = new PauseBTN();
			pause_btn.x = 40;
			pause_btn.y = 320
			addChild(pause_btn);
			pause_btn.addEventListener(MouseEvent.MOUSE_DOWN, handlePause);
			
			seek_btn = new SeekBTN();
			seek_btn.x = 70;
			seek_btn.y = 320
			addChild(seek_btn);
			seek_btn.addEventListener(MouseEvent.MOUSE_DOWN, handleSeek);
			
			color_btn = new ColorBTN();
			color_btn.x = 100;
			color_btn.y = 320
			addChild(color_btn);
			color_btn.addEventListener(MouseEvent.MOUSE_DOWN, handleColor);
			
			newVideo_btn = new NewVideoBTN();
			newVideo_btn.x = 130;
			newVideo_btn.y = 320
			addChild(newVideo_btn);
			newVideo_btn.addEventListener(MouseEvent.MOUSE_DOWN, handleNewVideo);
			
			size_btn = new SizeBTN();
			size_btn.x = 160;
			size_btn.y = 320
			addChild(size_btn);
			size_btn.addEventListener(MouseEvent.MOUSE_DOWN, handleResize);
			
			sound_btn = new MuteSoundBTN();
			sound_btn.x = 190;
			sound_btn.y = 320
			addChild(sound_btn);
			sound_btn.addEventListener(MouseEvent.MOUSE_DOWN, handleMuteSound);
			
			unload_btn = new UnloadBTN();
			unload_btn.x = 220;
			unload_btn.y = 320
			addChild(unload_btn);
			unload_btn.addEventListener(MouseEvent.MOUSE_DOWN, handleUnload);
			
			quit_btn = new QuitBTN();
			quit_btn.x = 250;
			quit_btn.y = 320;
			addChild(quit_btn);
			quit_btn.addEventListener(MouseEvent.MOUSE_DOWN, handleQuit);
			
			
			//this.stage.addEventListener(Event.RESIZE, handlePlayerResize);
			var title:ugylPlayerText = new ugylPlayerText();
			title.x = 10;
			title.y = 5; //350
			addChild(title);
			
		}
		
		
		///////////////////////////////////////////////////////////////////
		/////   Getting Data from Vimeo - Eventhandling Vimeo Player
		///////////////////////////////////////////////////////////////////
		private function handlePlayerLoaded(e:VimeoEvent):void
		{
			trace("Player Loaded");
			
			//Dispatch Event for the received Duration value
			durationView.text = "Duration " + String(vimeo_player.getDuration());
			
		}
		
		private function handleDuration(e:VimeoEvent):void
		{
			durationView.text = "Duration " + String(vimeo_player.getDuration());
		}
		
		private function handleVimeoStatus(e:VimeoEvent):void
		{
			//currentTimeView.text = "" + String(vimeo_player.getCurrentVideoTime() );
			currentTimeView.text = "" + String(e.currentTime );
			currentTimeView.text += (" " + e.info) ;
			
			if (e.info == VimeoPlayingState.VIDEO_COMPLETE)
			{
				if (counterPlayList < playlist.length -1)
				{
					vimeo_playNewVideo(playlist[counterPlayList]);
					vimeo_play();
					counterPlayList++;
				}
				
			}
		}
		
		
		/* Not important */
		/* private function handlePlayerResize(e:Event):void
		{
			var w:int = stage.width;
			var h:int = stage.height;
			vimeo_player_size(w, h);
		} */
		
		///////////////////////////////////////////////////////////////////
		/////   API - Flash control Vimeo - How to use the VimeoWrapper Class API
		///////////////////////////////////////////////////////////////////
		public function vimeo_play():void
		{
			vimeo_player.play();
		}
		
		public function vimeo_pause():void
		{
			vimeo_player.pause();
		}
		
		public function vimeo_seekTo(time:int):void
		{
			vimeo_player.seekTo(time);
		}
		
		public function vimeo_player_color(colorHexValueString:String):void
		{
			vimeo_player.changeColor(colorHexValueString);
		}
		
		public function vimeo_playNewVideo(videoID:int):void
		{
			vimeo_player.loadVideo(videoID);
		}
		
		public function vimeo_player_size(w:int, h:int):void
		{
			vimeo_player.setSize(w,h);
		}
		
		public function vimeo_set_volume(value:Number):void
		{
			vimeo_player.setVolume(value);
		}
		
		public function vimeo_unload_video():void
		{
			vimeo_player.unloadVideo();
		}
		
		///////////////////////////////////////////////////////////////////
		/////   EventHandling - Define the Interaction of the ugly Video Player
		///////////////////////////////////////////////////////////////////
		
		private function handlePlay(e:MouseEvent):void
		{
			vimeo_play();
		}
		
		private function handlePause(e:MouseEvent):void
		{
			vimeo_pause();
		}
		
		private function handleSeek(e:MouseEvent):void
		{
			vimeo_seekTo(4);
		}
		
		private function handleColor(e:MouseEvent):void
		{
			vimeo_player_color("FFAAFF");
		}
		
		private function handleNewVideo(e:MouseEvent):void
		{
			vimeo_playNewVideo(playlist[counterPlayList]);
			counterPlayList++;
		}
		
		private function handleResize(e:MouseEvent):void
		{
			vimeo_player_size(800, 600);
		}
		
		private function handleMuteSound(e:MouseEvent):void
		{
			vimeo_set_volume(0);
		}
		
		private function handleUnload(e:MouseEvent):void
		{
			vimeo_unload_video();
		}
		
		private function handleQuit(e:MouseEvent):void
		{
			vimeo_player.destroy();
		}
	} // End of class
}




